/*
 * ============================================================================
 * (C) Copyright IBM Corporation 2007, 2008.  All Rights Reserved.
 * 
 * You may only copy, modify, and distribute these samples internally.
 * These samples have not been tested under all conditions and are provided
 * to you by IBM without obligation of support of any kind.
 *
 * IBM PROVIDES THESE SAMPLES "AS IS" SUBJECT TO ANY STATUTORY WARRANTIES THAT
 * CANNOT BE EXCLUDED. IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR
 * CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT REGARDING THESE SAMPLES OR TECHNICAL SUPPORT, IF ANY.
 * ============================================================================
 */
import sample.kicker.SampleQueue;

def onGET() {
    // Browse contents of queue
    def queue = new SampleQueue(request.params.queueName[]);
    queue.connect();
    try {
        def messages = queue.browseMessages();
        request.view = 'JSON'
        request.json.output = prepareResponse(queue, "");
        request.json.output[].put("messages", messages);
        render();
    } finally {
        queue.disconnect();
    }
}

def onPOST() {
    // Post message to queue
    def queue = new SampleQueue(request.params.queueName[]);
    queue.connect();
    try {
        def messageText= request.params.messageText[]
        queue.postMessage(messageText)
        queue.commit();
        request.view = 'JSON'
        request.json.output = prepareResponse(queue,
            "Message posted: \"" + messageText + "\"."
            );
        render();
    } finally {
        queue.disconnect();
    }
}

def prepareResponse(SampleQueue queue, String status) {
    return [
        queue: queue.toString(),
        length: queue.getLength(),
        status: status
        ];
}

